# generated by datamodel-codegen:
#   filename:  assets.yml

from __future__ import annotations

from typing import Dict, List, Optional

from pydantic import Field

from cognite.well_model.base_model import WellsBaseModel


class Label(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    external_id: str = Field(
        ...,
        alias="externalId",
        description="The external ID provided by the client. Must be unique for the resource type.",
        example="well/12-4",
    )


class Asset(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    created_time: int = Field(
        ...,
        alias="createdTime",
        description="The number of milliseconds since 00:00:00 Thursday, 1 January 1970, Coordinated Universal Time (UTC), minus leap seconds.",
        example=1125631243,
    )
    last_updated_time: int = Field(
        ...,
        alias="lastUpdatedTime",
        description="The number of milliseconds since 00:00:00 Thursday, 1 January 1970, Coordinated Universal Time (UTC), minus leap seconds.",
        example=1125631243,
    )
    root_id: int = Field(
        ...,
        alias="rootId",
        description="The ID of the root asset. The root asset is the asset spanning the entire asset hierarchy that this asset belongs to.",
        example=1,
    )
    name: str = Field(..., description="The name of the asset.")
    id: int = Field(..., description="id of the corresponding CDF asset", example=1)
    parent_id: Optional[int] = Field(None, alias="parentId", description="id of the CDF parent", example=1)
    parent_external_id: Optional[str] = Field(
        None,
        alias="parentExternalId",
        description="The parent node's external ID used to specify the parent-child relationship.",
        example="well/12-4",
    )
    external_id: Optional[str] = Field(
        None,
        alias="externalId",
        description="The external ID provided by the client. Must be unique for the resource type.",
        example="well/12-4",
    )
    description: Optional[str] = Field(None, description="additional description for the data")
    data_set_id: Optional[int] = Field(
        None, alias="dataSetId", description="The id of the dataset this asset belongs to.", example=1
    )
    metadata: Optional[Dict[str, str]] = Field(None, description="metadata connected to the sequence")
    source: Optional[str] = None
    labels: Optional[List[Label]] = None
